#ifndef __MLC_H__
#define __MLC_H__

#include <vstypes.h>

#define RESERVED_AREA 64
#define MAX_ERASEBLOCKSIZE 4096 //2048 /* 2048=1MB 4096=2MB */
#define MAX_BADS 128      /* 128 erase blocks -- only whole erase blocks */
#define MAXREPL  2    /* Only space for 2! */

//#define DIRECT_WRITE /*write to original block if possible-- does not work!*/

#ifdef ASM

#define MLC_RETRIES 0 /*offset to retries field*/

#else

s_int16 Large8kPageWrite(u_int32 page, u_int16 *data, u_int16 *meta);
s_int16 Large8kPageRead(u_int32 page, u_int16 *data, u_int16 *meta);
s_int16 Large8kPageReadCompat(struct physical *ph, u_int32 page, u_int16 sectors, u_int16 *data, u_int16 *meta);
s_int16 Large8kPageReadSingle(struct physical *ph, u_int32 page,
			      u_int16 sectors, u_int16 *data, u_int16 *meta);
void NandPut8kPageSpareAddress(register __c u_int32 addr);


s_int16 LargePageWrite(u_int32 page, u_int16 *data, u_int16 *meta);
//s_int16 LargePageRead(u_int32 page, u_int16 *data, u_int16 *meta);
u_int16 GetBitArray(register __i0 u_int16 *array, register __a0 int bit);
void SetBitArray(register __i0 u_int16 *array, register __a0 int bit);
void ClearBitArray(register __i0 u_int16 *array, register __a0 int bit);

#define SECSPERPAGEBITS   4
#define SECTORSPERPAGE   16 //(1<<SECSPERPAGEBITS) //16
#define PAGESIZE       8192 //(512*SECTORSPERPAGE) //8192
struct REPL {
    __y u_int16 *data; /*initialized in checkmlc.c (moved to Y) */
    u_int32 orig;     /*original physical*/
    u_int32 new;      /*new/journal physical*/
    u_int32 logical;  /*logical sector at start of erase block*/
    u_int16 time;
    u_int16 bits;
#ifdef DIRECT_WRITE
    u_int16 wrDirect; /*write pointer for original block*/
#endif
    u_int16 wrPtr; /*write pointer*/
    u_int16 inOrder;  /*if journal blocks are in order */

    u_int32 sector;
    u_int32 phys;
    u_int16 se;
    u_int16 mask;

    u_int16 replbitmap[MAX_ERASEBLOCKSIZE/16/SECTORSPERPAGE];
};
extern u_int16 fmfCache[6144 /*MAXREPL*PAGESIZE/2*/]; /* x:0..17ff*/
struct MLC {
    u_int16 retries;    /* should be the first entry! */
    u_int32 dataStart;
    u_int16 rootBlock;  /*fits in 16 bits*/
    u_int32 dataBlocks; /*data size*/
    u_int16 bads;
    u_int16 bad[MAX_BADS];
    u_int16 badsChanged;

    u_int16 replaced;
    struct REPL replace[MAXREPL];
};

extern struct MLC mlc;
#endif/*else ASM*/

#endif/*__MLC_H__*/
