#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vs1000.h>

#include <player.h>
#include <mappertiny.h>
#include <minifat.h>
#include <vsNand.h>
#include <audio.h>
#include <dev1000.h>

//#define DUMP_LARGE_PAGE
//#define DUMP_8K
//#define ERASE_SECTOR
//#define DUMP_PHYS
//#define DUMP_FAT
//#define DUMP_DIR
//#define WR_SECTOR
//#define MAP_FMT
//#define WR_IMAGE
//#define WR_BITS
//#define MARK_BAD
#define ERASE_ALL
#define BAD_BLOCKS
//#define COPYBACK_WRITE

extern struct FsNandPhys fsNandPhys;
struct FmfMeta {
  u_int16 ecc01;
  u_int16 ecc2AndType;
  u_int16 reservedAndBadBlock;
  u_int16 unused;
  u_int32 logicalPageNo;	/* For root node, this is last used */
  s_int32 newBranch;		/* Page # for root node, non- -1 for others */
};
#define FS_MAP_NON_FULL 4

#define FMF_TYPE_INVALIDATED	  0
#define FMF_TYPE_ROOT		  1
#define FMF_TYPE_BRANCH2	  2
#define FMF_TYPE_BRANCH3	  3
#define FMF_TYPE_BRANCH4	  4
#define FMF_TYPE_DATA		  5
#define FMF_TYPE_UNUSED		255

#define FMF_BRANCH_LEVELS	4
#define FMF_EMPTY_BLOCKS	2




extern struct FsPhysical *ph;
extern struct FsMapper *map;
extern struct Codec *cod;
//extern struct CodecServices cs;

__y const char hex[] = "0123456789abcdef";
void puthex(u_int16 a) {
  char tmp[8];
  tmp[0] = hex[(a>>12)&15];
  tmp[1] = hex[(a>>8)&15];
  tmp[2] = hex[(a>>4)&15];
  tmp[3] = hex[(a>>0)&15];
  tmp[4] = ' ';
  tmp[5] = '\0';
  fputs(tmp, stdout);
}
void fputhex6(u_int32 a, FILE *fp) {
  char tmp[8];
  tmp[0] = hex[(a>>20)&15];
  tmp[1] = hex[(a>>16)&15];
  tmp[2] = hex[(a>>12)&15];
  tmp[3] = hex[(a>>8)&15];
  tmp[4] = hex[(a>>4)&15];
  tmp[5] = hex[(a>>0)&15];
  tmp[6] = '\0';
  fputs(tmp, fp);
}
void puthex6(u_int32 a) {
    fputhex6(a, stdout);
}
#define NAN 0x80000000L
long GetParam(char *str) {
  static char in[200];
  char *tmp;
  register int i;
  long value;
  if (str) {
    fputs(str, stdout);
    fflush(stdout);
  }
  fgets(in, 200, stdin);
  i = strlen(in);
  while (i && (in[i-1] == '\n' || in[i-1] == '\r'))
    in[--i] = '\0';
  value = strtol(in, &tmp, 0);
  if (!in[0] || (tmp && *tmp && *tmp != '\n' && *tmp != '\r'))
    return NAN;
  return value;
}
void PrintSector(u_int16 *data, u_int16 *spare) {
#if 0
  register int i, b = 0;
  if (data) {
    puts("d");
    for (i=0;i<256;i++) {
      if (data[i] != mallocAreaX[i]) {
	  if (b == 0) {
	      fputs("\033[1m", stdout);
	      b = 1;
	  }
	  puthex(data[i]);
      } else {
	  if (b) {
	      fputs("\033[0m", stdout);
	      b = 0;
	  }
	  puthex(data[i]);
      }
      if ((i&7) == 7)
	putchar('\n');
    }
    if (b) {
	fputs("\033[0m", stdout);
	b = 0;
    }
  }
  if (spare) {
    puts("s");
    for (i=0;i<8;i++)
      puthex(spare[i]);
    putchar('\n');
  }
  memcpy(mallocAreaX, data, 256);
#else
  register int i;
  if (data) {
    puts("d");
    for (i=0;i<256;i++) {
	puthex(data[i]);
	if ((i&7) == 7)
	    putchar('\n');
    }
  }
  if (spare) {
    puts("s");
    for (i=0;i<8;i++)
      puthex(spare[i]);
    putchar('\n');
  }
#endif
}

#define NandSelect() USEX(GPIO0_ODATA) &= ~GPIO0_CS1
#define NandDeselect() USEX(GPIO0_ODATA) |= GPIO0_CS1
void NandPutCommand (register __a0 u_int16 command);
void NandPutBlockAddress(register __c u_int32 addr);
void NandPutDataAddress(register __c u_int32 addr);
void NandPutLargePageSpareAddress(register __c u_int32 addr);
u_int16 NandGetStatus(void);
void NandPutAddressOctet(register __a0 u_int16 address);
void NandGetOctets(register __c0 s_int16 length, register __i2 u_int16 *buf);

#if 1
/* For 8k page size */

//#define NandSelect()   PERIP(GPIO0_CLEAR_MASK) = GPIO0_CS1
//#define NandDeselect() PERIP(GPIO0_SET_MASK) = GPIO0_CS1
void NandPutDataAddress(register __c u_int32 addr);
void NandPutAddressOctet(register __a0 u_int16 address);
u_int16 NandGetStatus(void);
void NandPutCommand(register __a0 u_int16 command);
void NandPutOctets(register __c0 s_int16 length, register __i2 u_int16 *buf);
void NandGetOctets(register __c0 s_int16 length, register __i2 u_int16 *buf);
void NandSetWaits(register __a0 u_int16 waitns);
extern struct FsNandPhys fsNandPhys;

#if 1
void NandPut8kDataAddress(register __c u_int32 addr);
#else
void NandPut8kDataAddress(register __c u_int32 addr) {
  // ** First put the offset address (index inside block)
  NandPutAddressOctet(0); // A0..A7 within 512B page, A8 not sent
  NandPutAddressOctet((addr & 15) << 1);

  NandPutAddressOctet(addr >> 4);
  NandPutAddressOctet(addr >> 12);
  NandPutAddressOctet(addr >> 20);
}
#endif

#if 1
void NandPut8kPageSpareAddress(register __c u_int32 addr);
#else
void NandPut8kPageSpareAddress(register __c u_int32 addr) {
    /* spares are starting from offset 8192 */
    // ** First put the offset address (index inside block)
    NandPutAddressOctet((addr & 15) << 4); /* 16 bytes per spare */
    NandPutAddressOctet(32);

    // ** Second: put the block address
    NandPutAddressOctet(addr >> 4);
    NandPutAddressOctet(addr >> 12);
    NandPutAddressOctet(addr >> 20);
}
#endif

#if 0
/* NandWaitReady() was required after PutNandCommand() when we had 100kOhm
   pull-up resistor on NFRDY. With 11kOhm it is not needed. VS1000 datasheet
   has recommended 10kOhm for a long time. */
s_int16 NandWaitReady(void) {
    register s_int16 n = 0;
    n = 0;
    while (!(PERIP(GPIO0_IDATA) & GPIO0_READY))
	n++;
#if 0
    puthex(n);
    puts("=waits");
#endif
    return n;
}
#endif

#if 0
void MyNandPutCommand(register __a0 u_int16 command) {
  NandWaitIdle();
  PERIP(GPIO0_ODATA) |= GPIO0_CLE; // pull NFlash CLE pin high
  PERIP(NFLSH_DSPIF) = 0;       // dbufEna=0, rd//wr=0
  PERIP(NFLSH_DATA) = command;// & 255;
  PERIP(NFLSH_NFIF) = NFLSH_NF_START;   // Write 1 octet
  NandWaitIdle();
  PERIP(GPIO0_ODATA) &= ~GPIO0_CLE;   // pull NFlash CLE pin low 
  NandWaitReady();
}
#define NandPutCommand MyNandPutCommand
#endif

#define DEBUG_LEVEL 1

/* Always writes 8k large-page: 8192+256 */
#if 1
s_int16 Large8kPageWrite(u_int32 page, u_int16 *data, u_int16 *meta);
#else
s_int16 Large8kPageWrite(u_int32 page, u_int16 *data, u_int16 *meta) {
#if DEBUG_LEVEL > 1
    puthex6(page);
    puts("=LPW");
#endif
  PERIP(GPIO0_SET_MASK) = GPIO0_CS1; //NandDeselect(); /* For robustness */
  NandSetWaits(fsNandPhys.waitns);
  PERIP(GPIO0_CLEAR_MASK) = GPIO0_CS1;//  NandSelect();

  NandPutCommand(NAND_OP_READ_A);/*Sets read/write pointer*/
  NandPutCommand(NAND_OP_PREPARE_TO_PROGRAM);
  NandPut8kDataAddress(page & ~15L); /* not valid if low 4 bits set! */

#ifdef PERIP_IN_X
  #define GET_ECC (*(u_int32 *)NFLSH_LPL)
#else
  #define GET_ECC (*(__y u_int32 *)NFLSH_LPL)
#endif
  {
      register __c1 u_int16 i;
      register __i3 u_int16 *m = meta;
      register __i1 u_int16 *d = data;
      for (i=0;i<16;i++) {
	  PERIP(NFLSH_DSPIF) = NFLSH_DF_ECC_RESET;
	  NandPutOctets(512, d);
	  m[0] = PERIP(NFLSH_LPL);
	  m[1] = (PERIP(NFLSH_CP_LPH)<<8) | (m[1] & 0xff);
#if DEBUG_LEVEL > 0
	  puthex6(GET_ECC);
	  puts("=ECC");
#endif
	  NandSwapBad(m);
	  d += 256;
	  m += 8;
      }
  }
  NandPutOctets(16*16,meta);
  /** Must restore the original order! */
  {
      register __c1 u_int16 i;
      register __i3 u_int16 *m = meta;
      for (i=0;i<16;i++) {
	  NandSwapBad(m);
	  m += 8;
      }
  }

  NandPutCommand(NAND_OP_PERFORM_PROGRAM); //Program the data and spare
  {
      register u_int16 n = NandGetStatus();
      PERIP(GPIO0_SET_MASK) = GPIO0_CS1;//      NandDeselect();

#if DEBUG_LEVEL != 0
      //if (!IsValid(page)) {
      //puts("Fail!");
      //}
#endif
      return (n & 1); //(n & 1) ? (s_int16)n : 0; //Error code from flash      
  }
}
#endif

#ifdef COPYBACK_WRITE
s_int16 Large8kPageCopyBackWrite(u_int32 page) {
  PERIP(GPIO0_SET_MASK) = GPIO0_CS1; //NandDeselect(); /* For robustness */
  NandSetWaits(fsNandPhys.waitns);
  PERIP(GPIO0_CLEAR_MASK) = GPIO0_CS1;//  NandSelect();

  NandPutCommand(NAND_OP_READ_A);/*Sets read/write pointer*/
  NandPutCommand(NAND_OP_COPY_BACK_PROGRAM);
  NandPut8kDataAddress(page & ~15L); /* not valid if low 4 bits set! */

/* TODO: bytes can be patched if necessary.. */

  NandPutCommand(NAND_OP_PERFORM_PROGRAM); //Program the data and spare
  {
      register u_int16 n = NandGetStatus();
      PERIP(GPIO0_SET_MASK) = GPIO0_CS1;//      NandDeselect();

#if DEBUG_LEVEL != 0
      if (n & 1) {
	  puthex(n);
	  puts("=COPYBACK");
      }
#endif
      return (n & 1); //(n & 1) ? (s_int16)n : 0; //Error code from flash      
  }
}
#endif


/* Always reads 8k large-page: 8192+256 */
#if 1
s_int16 Large8kPageRead(u_int32 page, u_int16 *data, u_int16 *meta);
#else
s_int16 Large8kPageRead(u_int32 page, u_int16 *data, u_int16 *meta) {
//  register s_int16 i;
  s_int16 err = 0;
  __y s_int16 reread = 0;
  __y u_int32 ecc[16];
  register __i3 u_int16 *d = data;
  register __i1 u_int16 *m = meta;

#ifdef PERIP_IN_X
  #define GET_ECC (*(u_int32 *)NFLSH_LPL)
#else
  #define GET_ECC (*(__y u_int32 *)NFLSH_LPL)
#endif
tryAgain:
  d = data;
  m = meta;
  PERIP(GPIO0_SET_MASK) = GPIO0_CS1;//      NandDeselect();
  NandSetWaits(fsNandPhys.waitns);
  PERIP(GPIO0_CLEAR_MASK) = GPIO0_CS1;//  NandSelect();

  NandPutCommand(NAND_OP_READ_A);
  NandPut8kDataAddress(page & ~15L);
  NandPutCommand(NAND_OP_COMMIT_DATA_ADDRESS);

  {
      register __i2 __y u_int32 *e = &ecc[0];
      register u_int16 n;
      for (n=0;n<16;n++) {
	  PERIP(NFLSH_DSPIF) = NFLSH_DF_ECC_RESET;
	  NandGetOctets(512, d);
	  d += 512/2;
	  *e++ = GET_ECC;
      }
  }
  d -= 16*512/2;
  NandGetOctets(16*16, m);

  {
      register __i2 __y u_int32 *e = &ecc[0];
      register u_int16 n;
      for (n=0;n<16;n++) {
	  register u_int32 xored;

	  /** swap first and sixth byte (bad block) */
	  NandSwapBad(m);

	  /* e1 e0 e2 05 ff bd ff ff l1 l0 l3 l2 ff ff ff ff  small-page */
	  xored = (((u_int32)(m[1] & 0xff00U)<<8) | m[0]) ^ *e++;
	  if (xored) {
	      register s_int16 oneBits = CountBitsLong(xored);
	      if (++reread <= 3) {
	      again:
#if DEBUG_LEVEL > 1
		  puthex(oneBits);
		  puthex6(page);
		  puts("@err(retry)");
#endif
		  //fsNandPhys.waitns += 1; /*!! find the right ws!*/

		  if ((PERIP(NFLSH_CTRL) & 31) < 30)
		      PERIP(NFLSH_CTRL) += 2;   // increase waitstates for retry
		  //PERIP(NFLSH_CTRL)++;   // lcc fails!
		  goto tryAgain;
	      }
	      if (oneBits == 1) {
		  /* Error in ECC, but data is ok: do nothing. */
#if DEBUG_LEVEL > 1
		  puthex6(page);
		  puts("@ECC err (don't worry)");
#endif
	      } else if (oneBits != 12) {
		  /* Fatal error: more than one error bits. */
#if DEBUG_LEVEL > 1
		  puthex(oneBits);
		  puts("@Uncorrectable err (sorry!)");
#endif
		  //goto again;
		  err = -1;
	      } else {
		  /* Correctable error. Correct it! */
		  register int line = NandMingle(xored);
		  register int col = (((line & 1) ^ 1) << 3) | (line >> 9);
#if DEBUG_LEVEL > 1
		  puthex(line & 0x1ff);
		  puthex(col & 7);
		  putchar(' ');
#endif
		  line = (line >> 1) & 0xff;
		  d[line] ^= 1<<col;
#if DEBUG_LEVEL > 1
		  puthex6(page);
		  puts("@Correctable err");
#endif
		  err |= 0x8000; //Needed correction
	      }
	  }
	  d += 512/2;
	  m += 16/2;
      }
  }
  PERIP(GPIO0_SET_MASK) = GPIO0_CS1;//      NandDeselect();
  return err;
}
#endif

#if 1
s_int16 Large8kPageReadCompat(struct physical *ph, u_int32 page, u_int16 sectors, u_int16 *data, u_int16 *meta);
#else
/* Read 512 bytes at a time. */
s_int16 Large8kPageReadCompat(struct physical *ph, u_int32 page, u_int16 sectors, u_int16 *data, u_int16 *meta) {
  s_int16 i;
  __y s_int16 reread = 0;
  __y u_int32 ecc;

#ifdef PERIP_IN_X
  #define GET_ECC (*(u_int32 *)NFLSH_LPL)
#else
  #define GET_ECC (*(__y u_int32 *)NFLSH_LPL)
#endif
  i = 0;
  while (1) {
      if (i >= sectors)
	  break;
tryAgain:
      PERIP(GPIO0_SET_MASK) = GPIO0_CS1;//      NandDeselect();
      if (data) {
	  NandSetWaits(fsNandPhys.waitns);
	  PERIP(GPIO0_CLEAR_MASK) = GPIO0_CS1;//  NandSelect();

#if DEBUG_LEVEL > 1
	  puthex6(page);
	  puts("=8k read single");
#endif
	  NandPutCommand(NAND_OP_READ_A);
	  NandPut8kDataAddress(page);
	  NandPutCommand(NAND_OP_COMMIT_DATA_ADDRESS);

	  PERIP(NFLSH_DSPIF) = NFLSH_DF_ECC_RESET;
	  NandGetOctets(512, data);
	  ecc = GET_ECC;
#if DEBUG_LEVEL > 1
	  puthex6(ecc);
	  puts("=ECCR");
#endif
	  PERIP(GPIO0_SET_MASK) = GPIO0_CS1;//      NandDeselect();
      }
      if (meta) {
	  NandSetWaits(fsNandPhys.waitns);
	  PERIP(GPIO0_CLEAR_MASK) = GPIO0_CS1;//  NandSelect();

	  NandPutCommand(NAND_OP_READ_A);
	  NandPut8kPageSpareAddress(page);
	  NandPutCommand(NAND_OP_COMMIT_DATA_ADDRESS);

	  NandGetOctets(16, meta);
	  PERIP(GPIO0_SET_MASK) = GPIO0_CS1;//      NandDeselect();

	  /** swap first and sixth byte (bad block) */
	  NandSwapBad(meta);

	  if (data /*&& meta*/) {
	      register u_int32 xored;
	  
	      /* e1 e0 e2 05 ff bd ff ff l1 l0 l3 l2 ff ff ff ff  small-page */
	      xored = (((u_int32)(meta[1] & 0xff00U)<<8) | meta[0]) ^ ecc;
	      if (xored) {
		  register s_int16 oneBits = CountBitsLong(xored);
		  if (++reread <= 3) {
		  again:
#if DEBUG_LEVEL > 1
		      puthex(oneBits);
		      puthex6(page);
		      puts("@err(retry)");
#endif
		      //fsNandPhys.waitns += 1; /*!! find the right ws!*/
		      if ((PERIP(NFLSH_CTRL) & 31) < 30)
			  PERIP(NFLSH_CTRL) += 2;   // increase waitstates for retry
		      //PERIP(NFLSH_CTRL)++;   // lcc fails!
		      goto tryAgain;
		  }
		  if (oneBits == 1) {
		      /* Error in ECC, but data is ok: do nothing. */
#if DEBUG_LEVEL > 1
		      puthex6(page);
		      puts("@ECC err (don't worry)");
#endif
		  } else if (oneBits != 12) {
		      /* Fatal error: more than one error bits. */
#if DEBUG_LEVEL > 1
		      puthex(oneBits);
		      puts("@Uncorrectable err (sorry!)");
#endif
		      //goto again;
		      return i; //err = -1;
		  } else {
		      /* Correctable error. Correct it! */
		      register int line = NandMingle(xored);
		      register int col = (((line & 1) ^ 1) << 3) | (line >> 9);
#if DEBUG_LEVEL > 1
		      puthex(line & 0x1ff);
		      puthex(col & 7);
		      putchar(' ');
#endif
		      line = (line >> 1) & 0xff;
		      data[line] ^= 1<<col;
#if DEBUG_LEVEL > 1
		      puthex6(page);
		      puts("@Correctable err");
#endif
		  }
	      }
	  }
	  meta += 16/2;
      }
      if (data) {
	  data += 512/2;
      }
      i++;
  }
  return i;
}
#endif

#if 1
s_int16 Large8kPageReadSingle(struct physical *ph, u_int32 page,
			      u_int16 sectors, u_int16 *data, u_int16 *meta);
#else
/* Read only one 512-byte secto at a time. */
s_int16 Large8kPageReadSingle(struct physical *ph, u_int32 page,
			      u_int16 sectors, u_int16 *data, u_int16 *meta) {
  s_int16 reread = 0;
  __y u_int32 ecc;
//  register u_int16 n;

#ifdef PERIP_IN_X
  #define GET_ECC (*(u_int32 *)NFLSH_LPL)
#else
  #define GET_ECC (*(__y u_int32 *)NFLSH_LPL)
#endif
tryAgain:
  PERIP(GPIO0_SET_MASK) = GPIO0_CS1;//      NandDeselect();
  if (data) {
      NandSetWaits(fsNandPhys.waitns); /*also acts as a CS1 high delay*/
      PERIP(GPIO0_CLEAR_MASK) = GPIO0_CS1;//  NandSelect();

      NandPutCommand(NAND_OP_READ_A);
      NandPut8kDataAddress(page);
      NandPutCommand(NAND_OP_COMMIT_DATA_ADDRESS);

      PERIP(NFLSH_DSPIF) = NFLSH_DF_ECC_RESET;
      NandGetOctets(512, data);
      ecc = GET_ECC;
      PERIP(GPIO0_SET_MASK) = GPIO0_CS1;//      NandDeselect();
  }
  if (meta) {
      NandSetWaits(fsNandPhys.waitns); /*also acts as a CS1 high delay*/
      PERIP(GPIO0_CLEAR_MASK) = GPIO0_CS1;//  NandSelect();

      NandPutCommand(NAND_OP_READ_A);
      NandPut8kPageSpareAddress(page);
      NandPutCommand(NAND_OP_COMMIT_DATA_ADDRESS);

      NandGetOctets(16, meta);
      PERIP(GPIO0_SET_MASK) = GPIO0_CS1;//      NandDeselect();

      /** swap first and sixth byte (bad block) */
      NandSwapBad(meta);

      if (data /*&& meta*/) {
	  register u_int32 xored;

	  /* e1 e0 e2 05 ff bd ff ff l1 l0 l3 l2 ff ff ff ff  small-page */
	  xored = (((u_int32)(meta[1] & 0xff00U)<<8) | meta[0]) ^ ecc;
	  if (xored) {
	      register s_int16 oneBits = CountBitsLong(xored);
	      if (++reread <= 3) {
	      again:
#if DEBUG_LEVEL > 1
		  puthex(oneBits);
		  puthex6(page);
		  puts("@err(retry)");
#endif
		  //fsNandPhys.waitns += 1; /*!! find the right ws!*/
		  if ((PERIP(NFLSH_CTRL) & 31) < 30)
		      PERIP(NFLSH_CTRL) += 2;   // increase ws for retry
		  //PERIP(NFLSH_CTRL)++;   // lcc fails!
		  goto tryAgain;
	      }
	      if (oneBits == 1) {
		  /* Error in ECC, but data is ok: do nothing. */
#if DEBUG_LEVEL > 1
		  puthex6(page);
		  puts("@ECC err (don't worry)");
#endif
	      } else if (oneBits != 12) {
		  /* Fatal error: more than one error bits. */
#if DEBUG_LEVEL > 1
		  puthex(oneBits);
		  puts("@Uncorrectable err (sorry!)");
#endif
		  return 0;
	      } else {
		  /* Correctable error. Correct it! */
		  register int line = NandMingle(xored);
		  register int col = (((line & 1) ^ 1) << 3) | (line >> 9);
#if DEBUG_LEVEL > 1
		  puthex(line & 0x1ff);
		  puthex(col & 7);
		  putchar(' ');
#endif
		  line = (line >> 1) & 0xff;
		  data[line] ^= 1<<col;
#if DEBUG_LEVEL > 1
		  puthex6(page);
		  puts("@Correctable err");
#endif
	      }
	  }
      }
  }
  return 1;
}
#endif

#if 0
s_int16 FsPh8kNandRead(struct FsPhysical *p, s_int32 firstPage,
		       u_int16 pages, u_int16 *data, u_int16 *meta) {
  register int i;
  NandSetWaits(fsNandPhys.waitns);
  for (i=0; i<pages; i++) {
  }
  return i
}
#endif


#endif

#if 0
s_int16 Large8kPageErase(struct FsPhysical *p, s_int32 block){
  s_int16 result;

  NandDeselect();
  NandSetWaits(fsNandPhys.waitns);
  NandSelect();
  NandPutCommand(0x60);

#if 0
  NandPutBlockAddress(block>>2);
#else
  // ** Second: put the block address
  NandPutAddressOctet(block >> 4);
  NandPutAddressOctet(block >> 12);
  NandPutAddressOctet(block >> 20);
#endif
  NandPutCommand(0xD0);
  result = NandGetStatus();
  NandDeselect();
  if (result & 1) {
    return result;
  }
  return 0;
}
#endif

#if 1
u_int16 NandGetIdent(void){
  u_int16 ident[4];
#if 0
  NandDeselect();
  NandSelect();
  NandPutCommand(0xff /*NAND_OP_RESET*/);
  //NandDeselect();
#endif

  NandDeselect();
  NandSelect();
  NandPutCommand(NAND_OP_READ_SIGNATURE);
  NandPutAddressOctet(0);
  NandGetOctets(8,ident);
  NandDeselect();
  fputs("Nand Signature: ",stdout);
  /*
    2cdc 9095 5400 MT29F4G08AAA
    ecd3 14a5 64ec K9G8G08U0A-PCB0   8Gb MLC  type=3 bl=9 sz=21
    ecd5 55a5 68ec K9LAG08U0A-PCB0  16Gb MLC  type=3 bl=9 sz=22 (2 dies)
    add3 14a5 34ad HY27UT088G2A-TPC8 8Gb MLC  type=3 bl=9 sz=21
    add3 14a5 64ad HY27UU08AG5M          MLC  type=3 bl=9 sz=22(21) (2 /CS, 2 R/B)
    ecdc 1095 54ec K9F4G08UOA

    e8d1 9029 3041 K9GAG08U0B MLC
    ecd5 8472 5042 K9GAG08U0E-SCB0 MLC
  */
  /*
    1st byte: maker code
    2nd byte: device code
    3rd & 4th byte: parameters
   */
#if 1
  {
    register int i;
    for (i=0; i<3; i++){
      puthex(ident[i]);
    }
  }
  fputs("\n",stdout);
#endif

#if 0
  puthex(1 << ((ident[1]>>8) & 3));
  puts("dies");
  puthex(((ident[1] >> 10) & 3) + 1);
  puts("bits/cell");
  puthex(1 << ((ident[1] >> 12) & 3));
  puts("sim.prog.pages");
//  puts((ident[1] & 0x4000U) ? "Interleaved program" : "No interleaved program");
//  puts((ident[1] & 0x8000U) ? "Cache program" : "No cache program");
  puthex((ident[1] & 3)+1);
  puts("kB page");
  puthex(64 << ((ident[1] >> 4) & 3));
  puts("kB block");
#endif
#if 1
  puthex(1 << ((ident[1]>>8) & 3));
  puts("dies");
  puthex(((ident[1] >> 10) & 3) + 1);
  puts("bits/cell");
  puthex(1 << ((ident[1] >> 12) & 3));
  puts("sim.prog.pages");
  puts((ident[1] & 0x4000U) ? "Interleaved program" : "No interleaved program");
  puts((ident[1] & 0x8000U) ? "Cache program" : "No cache program");
  {
      static const char *pageSize[4] = {
	  "2kB page",
	  "4kB page",
	  "8kB page",
	  "reserved page size",
      };
      puts(pageSize[ident[1]&3]);
  }
  puthex(128 << ((ident[1] >> 4) & 3));
  puts("kB block");
  puthex(1<<((ident[2]>>10)&3));
  puts(" planes");
  if (0) {
      static const char *eccLevel[8] = {
	  "1bit/512B",
	  "2bit/512B",
	  "4bit/512B",
	  "8bit/512B",
	  "16bit/512B",
	  "24bit/1kB",
	  "reserved",
	  "reserved",
      };
      fputs("ECC Level: ", stdout);
      puts(eccLevel[((ident[2]>>12)&7)]);
  }
#endif
  return ident[0];
}
#endif

void main(void) {
    ph = FsPhNandCreate(1);

#if 0
  /* Send RESET command -- is mandatory with some flashes */
  NandDeselect();
  NandSelect();
  NandPutCommand(0xff /*NAND_OP_RESET*/);
  NandDeselect();
#endif


//  ph->Read = Large8kPageReadCompat;
  ph->Read = Large8kPageReadSingle;
  while (1) {
    static char in[200];
    char *tmp;
    int mode;

    puthex(((struct FsNandPhys *)ph)->nandType);
    puts("=nT");
    puthex6(ph->eraseBlockSize);
    puts("=eraseBlockSize");
    puthex6(ph->eraseBlocks);
    puts("=eraseBlocks");
    puthex(fsNandPhys.waitns);
    puts("=ws");
    NandGetIdent();

#if 0
    memset(minifatBuffer, 0xffff, 256/2);
    memset(mallocAreaX, 0, 8192/2);
    for (mode = 0; mode < 16; mode++)
	mallocAreaX[mode * 256] = mode;
    for (mode = 0; mode < 16; mode++)
	minifatBuffer[mode * 8 + 2] = mode;
    Large8kPageWrite(0, mallocAreaX, minifatBuffer);
#endif

#ifdef BAD_BLOCKS
    puts("\n  1) Badblocks");
#endif
#ifdef DUMP_PHYS
    puts("  2) Dump phys");
#endif
#ifdef DUMP_LARGE_PAGE
    puts("  2) Dump phys (large-page)");
#endif
#ifdef DUMP_8K
    puts("  2) Dump phys (8k-page)");
#endif
#ifdef DUMP_FAT
    puts("  3) Dump fat");
#endif
#ifdef DUMP_DIR
    puts("  4) Dump directory");
#endif
    puts("  5) Send Reset");
    //puts("100) Determine flash type");
    //puts("101) Determine nand size");
#ifdef ERASE_ALL
    puts("111) Erase all");
#endif
    puts("120) Init flash");
#ifdef MAP_FMT
    puts(" 50) Map fmt");
#endif
    puts(" 10) Pr sectors");
#ifdef ERASE_SECTOR
    puts(" 11) Er block");
#endif
#ifdef WR_SECTOR
    puts(" 12) Wr block");
#endif
#ifdef MARK_BAD
    puts(" 13) Mark bad");
#endif
#ifdef WR_IMAGE
    puts(" 14) program img");
#endif
#ifdef WR_BITS
    puts(" 15) write 0-bits");
#endif
#ifdef COPYBACK_WRITE
    puts(" 16) copyback write 0x1800 to 0x80000");
#endif
    fputs("\ncommand: ", stdout);
    fflush(stdout);

    if (!fgets(in, 200, stdin))
	return;
#if 1
    mode = strtol(in, &tmp, 0);
#else
    {
	register s_int16 *p = in;
	mode = 0;
	while (*p >= '0' && *p <= '9') {
	    mode *= 10;
	    mode += *p - '0';
	    p++;
	}
    }
#endif
    if (tmp && *tmp && *tmp != '\n' && *tmp != '\r') {
//      puts("Inv");
      continue;
    }
    switch (mode) {
#ifdef WR_BITS
    case 15:
    {
	int i;
	u_int32 sector = 0;

	fputs("sector: ", stdout);
	fflush(stdout);
	fgets(in, 200, stdin);
	sector = strtol(in, &tmp, 0);
	if (!in[0])// || (tmp && *tmp && *tmp != '\n' && *tmp != '\r'))
	  break;

	fputs("bit: ", stdout);
	fflush(stdout);
	fgets(in, 200, stdin);
	i = strtol(in, &tmp, 0);
	if (!in[0])// || (tmp && *tmp && *tmp != '\n' && *tmp != '\r'))
	  break;

#if 0
	memset(minifatBuffer, -1, 512/2);
	minifatBuffer[i/16] ^= 1 << (i&15);
	ph->Write(ph, sector, 1, minifatBuffer, NULL);
#else
	memset(tmpBuf, -1, 512/2);
	tmpBuf[i/16] ^= 1 << (i&15);
	ph->Write(ph, sector, 1, NULL, tmpBuf);
#endif
	puthex(i);
	puts("Written");
    }
	break;
#endif

#ifdef WR_IMAGE
    case 14:
    {
	FILE *fp;
	int i;

	fputs("Filename: ", stdout);
	fflush(stdout);
	fgets(in, 200, stdin);
	i = strlen(in);
	while (i && (in[i-1] == '\n' || in[i-1] == '\r'))
	    in[--i] = '\0';

	fp = fopen(in, "rb");
	if (fp) {
	    u_int32 sector = 0;
	    ph->Erase(ph, 0);
	    PERIP(INT_ENABLEL) &= ~INTF_RX;
	    while (fread(minifatBuffer, 1, 512/2, fp)) {
		memset(tmpBuf, -1, 16/2);
		if (ph->Write(ph, sector, 1, minifatBuffer, tmpBuf) != 1) {
		    puts("WrError");
		}
		sector++;
		memset(minifatBuffer, -1, 512/2);
	    }
	    fclose(fp);
	    puthex(sector);
	    puts("=sectors written");
	    PERIP(INT_ENABLEL) |= INTF_RX;
	}
        break;
    }
#endif

#ifdef MARK_BAD
    case 13:
      while (1) {
	  long bad;
	  fputs("Mark eraseblock bad: ", stdout);
	  fflush(stdout);
	  fgets(in, 40, stdin);
	  bad = strtol(in, &tmp, 0);
	  if (tmp && *tmp && *tmp != '\n' && *tmp != '\r') {
	      puts("Inv");
	      break;
	  }
	  if (bad >= 1 && bad < (u_int32)ph->eraseBlockSize * ph->eraseBlocks) {
	      memset(mallocAreaX, -1, 8192/2);
	      memset(minifatBuffer, -1, 16*16/2);
	      minifatBuffer[0+2] = 0xff00;
//	      ph->Write(ph, ph->eraseBlockSize*(u_int32)bad, 1, NULL, minifatBuffer);
	      ph->Erase(ph, bad >> 2);
	      Large8kPageWrite(bad, mallocAreaX, minifatBuffer);
	  }
      }
      break;
#endif
    case 100:
	((struct FsNandPhys *)ph)->nandType =
	    (((struct FsNandPhys *)ph)->nandType + 1) & 7;
      break;

    case 10:
    {
      u_int32 sector;
      int i;

      while (1) {
	sector = GetParam("sector: ");
	if (sector == NAN)
	    break;
#if 0
	if (ph->Read(ph, sector, 1, minifatBuffer, tmpBuf) != 1) {
	  puthex(fsNandPhys.waitns);
	  puts("Error");
	}
	PrintSector(minifatBuffer, tmpBuf);
	puts("");
#else
	if (i = Large8kPageReadForCopyBack(sector, mallocAreaX, minifatBuffer)) {
	    if (i & 0x7fff) {
		puthex(i);
		puthex(fsNandPhys.waitns);
		puts("Error");
	    } else {
		puts("Error Corrected");
	    }
	}
	PrintSector(mallocAreaX+512/2*((u_int16)sector & 15),
		    minifatBuffer + 16/2*((u_int16)sector & 15));
	puts("");
#endif
      }
      break;
    }
#ifdef WR_SECTOR
    case 12:
    {
      u_int32 sector;
      int i;

      while (1) {
	fputs("sector: ", stdout);
	fflush(stdout);
	fgets(in, 200, stdin);
	i = strlen(in);
	while (i && (in[i-1] == '\n' || in[i-1] == '\r'))
	  in[--i] = '\0';
	sector = strtol(in, &tmp, 0);
	if (!in[0] || (tmp && *tmp && *tmp != '\n' && *tmp != '\r'))
	  break;

	memset(tmpBuf, -1, 8);
	memset(minifatBuffer, -1, 256);
	minifatBuffer[0] = sector>>16;
	minifatBuffer[1] = sector;
	if (ph->Write(ph, sector, 1, minifatBuffer, tmpBuf) != 1) {
	  puts("WrError");
	}
	if (ph->Read(ph, sector, 1, minifatBuffer, tmpBuf) != 1) {
	  puts("RdError");
	}
	PrintSector(minifatBuffer, tmpBuf);
	puts("");
      }
      break;
    }
#endif

#ifdef ERASE_SECTOR
    case 11:
    {
      u_int32 sector;
      int i;

      while (1) {
#if 0
	fputs("Erase sector: ", stdout);
	fflush(stdout);
	fgets(in, 200, stdin);
	i = strlen(in);
	while (i && (in[i-1] == '\n' || in[i-1] == '\r'))
	  in[--i] = '\0';
	sector = strtol(in, &tmp, 0);
	if (!in[0])// || (tmp && *tmp && *tmp != '\n' && *tmp != '\r'))
	  break;
#else
	sector = GetParam("Erase sector: ");
	if (sector == NAN)
	    break;
#endif
	if (ph->Erase(ph, sector>>2)) {
	  puts("Error");
	}
	//PrintSector(minifatBuffer, tmpBuf);
	//puts("");
      }
      break;
    }
#endif

#ifdef ERASE_ALL
    case 111:
      /* Erase all */
    {
      u_int32 sector, sectors = (u_int32)ph->eraseBlockSize * ph->eraseBlocks;
      int i;
      FILE *fp;

      puthex6(ph->eraseBlockSize);
      puts("=eraseBlockSize");
      puthex6(ph->eraseBlocks);
      puts("=eraseBlocks");
      puthex6(sectors);
      puts("=sectors");

      for (sector = 0x0; sector < sectors; sector += ph->eraseBlockSize) {
	if (ph->Erase(ph, sector>>2)) {
	  puthex6(sector);
	  puts("Error");
#if 1
	  memset(tmpBuf, 0xffffU, 8);
	  tmpBuf[0+2] = 0;
	  ph->Write(ph, sector, 1, NULL, tmpBuf);
#endif
	}
      }
      break;
    }
#endif /*ERASE_ALL*/

#ifdef MAP_FMT
    case 51:
	if (!(ph->eraseBlocks & 1))
	    ph->eraseBlocks--;
	/* fall through */
    case 50:
#if 1
	puthex(ph->eraseBlockSize);
	putchar(' ');
	puthex(ph->eraseBlocks);
	puts("=block size,erase blocks");
      map = FsMapFlCreate(ph, 1); /* format */
      map->Flush(map, 1);
      map->Delete(map);
      puthex(map->blocks>>16);
      puthex(map->blocks);
      puts("=map blocks: Mapper format complete");
#endif
      break;
#endif

#ifdef BAD_BLOCKS
    case 1:
      /* Scan for bad blocks */
    {
      u_int32 sector, sectors = (u_int32)ph->eraseBlockSize * ph->eraseBlocks;
      int i;
#if 0
      FILE *fp;
      fputs("Filename (or empty): ", stdout);
      fflush(stdout);
      fgets(in, 200, stdin);
      i = strlen(in);
      while (i && (in[i-1] == '\n' || in[i-1] == '\r'))
	in[--i] = '\0';
#endif
      puthex6(ph->eraseBlockSize);
      puts("=eraseBlockSize");
      puthex6(ph->eraseBlocks);
      puts("=eraseBlocks");
#if 0
      puthex6(sectors);
      puts("=sectors");
      if (in[0] && (fp = fopen(in, "wb"))) {
	fputs("Dumping bad blocks to \"", stdout);
	fputs(in, stdout);
	puts("\"\n");
      } else {
	fp = stdout;
      }
#endif
      puts("Scanning Bad Blocks");
      for (sector = 0x0; sector < sectors;
#if 0
	   sector += 4
#else
	       sector += ph->eraseBlockSize
#endif
	  ) {
	memset(tmpBuf, 0xffff, sizeof(tmpBuf));
	if (ph->Read(ph, sector, 2, NULL, tmpBuf) != 2) {
	}
	if ((tmpBuf[0+2] & 0xff) != 0xff
	    || (tmpBuf[8+2] & 0xff) != 0xff) {
	    fputhex6(sector, stdout/*fp*/);
	    fputs("=B\n", stdout/*fp*/);
	}
      }
#if 0
      if (fp && fp != stdout)
	fclose(fp);
#endif
      puts("Done\n");
      break;
    }
#endif /*BAD_BLOCKS*/

#ifdef DUMP_8K
    case 2:
      /* dump physical - large page mode */
    {
      u_int32 sector, sectors =
	(u_int32)ph->eraseBlockSize * ph->eraseBlocks;
      u_int32 __y na = 0;
      FILE *fp;
      int i;

      fputs("Filename: ", stdout);
      fflush(stdout);
      fgets(in, 200, stdin);
      i = strlen(in);
      while (i && (in[i-1] == '\n' || in[i-1] == '\r'))
	in[--i] = '\0';

      puthex6(sectors);
      puts("=sectors");

      fp = fopen(in, "wb");
      if (fp) {
	fputs("Dumping Physical (8k-page) to \"", stdout);
	fputs(in, stdout);
	puts("\"\n");
	for (sector = 0x0; sector < sectors; sector += 16) {
	  if ((sector & 0x1ff) == 0) {
	    putchar('\r');
	    puthex6(sector);
	    putchar(' ');
	    puthex6(na);
	    fflush(stdout);
	  }
	  /*Note: ph->Read(ph, sector, 4, mallocAreaX, tmpBuf);
	          does not work! */
#if 1
	  //Large8kPageRead(sector, NULL, minifatBuffer);
	  if (Large8kPageRead(sector, mallocAreaX, minifatBuffer) & 0x7fff) {
	      na++;
	  }
	  fwrite(mallocAreaX, 16*512/2, 1, fp);
#else
	  ph->Read(ph, sector, 4, NULL, tmpBuf);
	  if (ph->Read(ph, sector, 4, mallocAreaX, NULL) != 4) {
	    na++;
#if 0
	    puthex6(sector);
	    puts(" N/A");
#endif
	  }
	  fwrite(mallocAreaX, 4*512/2, 1, fp);
	  /* Swap all back to make it valid for NAND programmer */
	  NandSwapBad(tmpBuf+0);
	  NandSwapBad(tmpBuf+8);
	  NandSwapBad(tmpBuf+16);
	  NandSwapBad(tmpBuf+24);
	  fwrite(tmpBuf, 4*16/2, 1, fp);
#endif
	}
	fclose(fp);
	putchar('\n');
	puthex6(na);
	puts("=N/A\nDump done.");
      } else {
#if 0
	fputs("Could not open \"", stdout);
	fputs(in, stdout);
	puts("\" for writing\n");
#endif
      }
      break;
    }
#endif/*DUMP_8K*/

#ifdef DUMP_LARGE_PAGE
    case 2:
      /* dump physical - large page mode */
    {
      u_int32 sector, sectors =
	(u_int32)ph->eraseBlockSize * ph->eraseBlocks;
      u_int32 __y na = 0;
      FILE *fp;
      int i;

      fputs("Filename: ", stdout);
      fflush(stdout);
      fgets(in, 200, stdin);
      i = strlen(in);
      while (i && (in[i-1] == '\n' || in[i-1] == '\r'))
	in[--i] = '\0';
#if 0
      puthex6(ph->eraseBlockSize);
      puts("=eraseBlockSize");
      puthex6(ph->eraseBlocks);
      puts("=eraseBlocks");
#endif
      puthex6(sectors);
      puts("=sectors");

      fp = fopen(in, "wb");
      if (fp) {
	fputs("Dumping Physical (large-page) to \"", stdout);
	fputs(in, stdout);
	puts("\"\n");
	for (sector = 0x0; sector < sectors; sector += 4) {
	  if ((sector & 0x1ff) == 0) {
	    putchar('\r');
	    puthex6(sector);
	    putchar(' ');
	    puthex6(na);
	    fflush(stdout);
	  }
	  /*Note: ph->Read(ph, sector, 4, mallocAreaX, tmpBuf);
	          does not work! */
	  ph->Read(ph, sector, 4, NULL, tmpBuf);
	  if (ph->Read(ph, sector, 4, mallocAreaX, NULL) != 4) {
	    na++;
#if 0
	    puthex6(sector);
	    puts(" N/A");
#endif
	  }
	  fwrite(mallocAreaX, 4*512/2, 1, fp);
	  /* Swap all back to make it valid for NAND programmer */
	  NandSwapBad(tmpBuf+0);
	  NandSwapBad(tmpBuf+8);
	  NandSwapBad(tmpBuf+16);
	  NandSwapBad(tmpBuf+24);
	  fwrite(tmpBuf, 4*16/2, 1, fp);
	}
	fclose(fp);
	putchar('\n');
	puthex6(na);
	puts("=N/A\nDump done.");
      } else {
#if 0
	fputs("Could not open \"", stdout);
	fputs(in, stdout);
	puts("\" for writing\n");
#endif
      }
      break;
    }
#endif
#ifdef DUMP_PHYS
    case 2:
      /* dump physical */
    {
      u_int32 sector, sectors =
	(u_int32)ph->eraseBlockSize * ph->eraseBlocks;
      u_int32 __y na = 0;
      FILE *fp;
      int i;

      fputs("Filename: ", stdout);
      fflush(stdout);
      fgets(in, 200, stdin);
      i = strlen(in);
      while (i && (in[i-1] == '\n' || in[i-1] == '\r'))
	in[--i] = '\0';

      puthex6(ph->eraseBlockSize);
      puts("=eraseBlockSize");
      puthex6(ph->eraseBlocks);
      puts("=eraseBlocks");
      puthex6(sectors);
      puts("=sectors");

      fp = fopen(in, "wb");
      if (fp) {
#if 0
	fputs("Dumping Physical to \"", stdout);
	fputs(in, stdout);
	puts("\"\n");
#endif
	for (sector = 0x0; sector < sectors; sector++) {
	  if ((sector & 0x1ff) == 0) {
	    putchar('\r');
	    puthex6(sector);
	    //putchar(' ');
	    //puthex6(na);
	    fflush(stdout);
	  }

#if 0
	  ph->Read(ph, sector, 1, NULL, tmpBuf);
	  ph->Read(ph, sector, 1, minifatBuffer, NULL);
	  puthex(PERIP(NFLSH_LPL));
	  puthex(PERIP(NFLSH_CP_LPH));
	  puts("=LPL,CP,LPH");
	  if (0)
#else
	  if (ph->Read(ph, sector, 1, minifatBuffer, tmpBuf) != 1)
#endif
	  {
	    na++;
#if 0
	    puthex6(sector);
	    puts(" N/A");
#endif
	  }
//	  fwrite(tmpBuf, 16/2, 1, fp);
	  fwrite(minifatBuffer, 512/2, 1, fp);
	}
	fclose(fp);
	putchar('\n');
	//puthex6(na);
	puts("=N/A\nDump done.");
      } else {
#if 0
	fputs("Could not open \"", stdout);
	fputs(in, stdout);
	puts("\" for writing\n");
#endif
      }
      break;
    }
#endif

#ifdef DUMP_FAT
    case 3:
    {
      u_int32 sector, sectors;
      FILE *fp;
      int i;

      fputs("Filename: ", stdout);
      fflush(stdout);
      fgets(in, 200, stdin);
      i = strlen(in);
      while (i && (in[i-1] == '\n' || in[i-1] == '\r'))
	in[--i] = '\0';

      puts("Tiny-Mapper");
      map = FsMapTnCreate(ph, 0); /* tiny mapper */
      sectors = map->blocks;

      /* Dump fat */
      puthex6(sectors);
      puts("=sectors");

      fp = fopen(in, "wb");
      if (fp) {
	fputs("Dumping Logical (FAT) to \"", stdout);
	fputs(in, stdout);
	puts("\"\n");
	for (sector = 0x0; sector < sectors; sector++) {
	  if ((sector & 0x1ff) == 0) {
	    putchar('\r');
	    puthex(sector);
	    fflush(stdout);
	  }
	  if (map->Read(map, sector, 1, minifatBuffer) != 1) {
	    memset(minifatBuffer, 0, 256);
#if 0
	    puthex6(sector);
	    puts(" N/A");
#endif
	  }
	  fwrite(minifatBuffer, 512/2, 1, fp);
	}
	fclose(fp);
	puts("Dump done");
      } else {
	fputs("Could not open \"", stdout);
	fputs(in, stdout);
	puts("\" for writing\n");
      }
      map->Delete(map);
      break;
    }
#endif

#ifdef DUMP_DIR
    case 4:
    {
      u_int32 sector, sectors;
      int i;

      puts("Tiny-Mapper");
      map = FsMapTnCreate(ph, 0); /* tiny mapper */

      if (InitFileSystem() == 0) {
	  player.totalFiles = OpenFile(0xffffU);
	  puthex(player.totalFiles);
	  puts("=totalFiles");
	  for (i=0;i<player.totalFiles;i++) {
	      int j;
	      OpenFile(i);
	      puthex6(minifatInfo.fileSize);
	      putchar(' ');
	      for (j=0;j<6;j++) {
		  putchar(minifatInfo.fileName[j]>>8);
		  putchar(minifatInfo.fileName[j]);
	      }
	      puts("");
	  }
      } else {
	puts("InitFileSystem() failed for writing\n");
      }
      break;
    }
#endif

    case 120:
    {
      int blockSizeExp = 5, flashSizeExp = 18;
      long wsns = GetParam("Waits (ns): ");
      __y long tmp;
      if (wsns == NAN)
	break;

      tmp = GetParam("NandType: ");
      if (tmp == NAN)
	break;
      ((struct FsNandPhys *)ph)->nandType = tmp;
      ((struct FsNandPhys *)ph)->waitns = wsns;

      tmp = GetParam("blockSizeExpr: ");
      if (tmp == NAN)
	break;
      blockSizeExp = tmp;
      ph->eraseBlockSize = (1 << blockSizeExp);
      tmp = GetParam("flashSizeExpr: ");
      if (tmp == NAN)
	break;
      flashSizeExp = tmp;
      ph->eraseBlocks = 1 << (flashSizeExp-blockSizeExp);

      puthex(1<<blockSizeExp);
      puts("=eraseBlockSize");
      puthex(ph->eraseBlocks);
      puts("=eraseBlocks");


      ph->Erase(ph, 0);
      memset(minifatBuffer, -1, 256/2);
      memset(mallocAreaX, -1, 8192/2);
      mallocAreaX[0] = ('V' << 8) + 'L';
      mallocAreaX[1] = ('S' << 8) + 'I';
      mallocAreaX[2] = ((struct FsNandPhys *)ph)->nandType;
      mallocAreaX[3] = (blockSizeExp << 8) + flashSizeExp;
      mallocAreaX[4] = ((struct FsNandPhys *)ph)->waitns;

#if 0
      ph->Write(ph, 0, 1, mallocAreaX, minifatBuffer);
#else
      Large8kPageWrite(0, mallocAreaX, minifatBuffer);


      //Large8kPageRead(0, mallocAreaX, minifatBuffer);
      //PrintSector(mallocAreaX, minifatBuffer);
#endif

      puts("Inited");
      break;
    }

#if 0
    case 5:
	/* Send RESET command -- is mandatory with some flashes */
	NandDeselect();
	NandSelect();
	NandPutCommand(0xff /*NAND_OP_RESET*/);
	NandDeselect();
	break;
#endif

#ifdef COPYBACK_WRITE
    case 16:
    {
	u_int32 sector;
	__y u_int32 start = ReadTimeCount();
	//puts(" 16) copyback write 0x1800 to 0x80000");
	start = ReadTimeCount() - start;
	ph->Erase(ph, 0x80000 >> 2);
	puthex(start>>16);
	puthex(start);
	puts("=Erase");
	start = ReadTimeCount();
	/*
	  Normal:   $4b = 75
	  Copyback: $33 = 51
	  speedup:  +50%
	 */
	for (sector = 0; sector < ph->eraseBlockSize; sector += 16) {
	    if (Large8kPageRead(0x1800 + sector, mallocAreaX, minifatBuffer)) {
		/* Needed correction or failed, must send completely */
		Large8kPageWrite(0x80000 + sector, mallocAreaX, minifatBuffer);
	    } else {
		/* ok, can use copyback write */
		Large8kPageCopyBackWrite(0x80000 + sector);
	    }
	}
	start = ReadTimeCount() - start;
	puthex(start>>16);
	puthex(start);
	puts("=Time");
    }
#endif

    default:
      puthex(mode);
      puts("mode");
    }
  }
}

/*
  Hynix HY27UT084G2 MLC 512MB

0100  0fff =block size,erase blocks
000e 6500 =map blocks: Mapper format complete
0003 =nT
000100=eraseBlockSize
000fff=eraseBlocks


block 256:
Data  ...
Spare 0000 0001 ffff ffff 0100 0000 ffff ffff 
      -------ECC     ----unused
             --type=ROOT  ---------logical page number 0x00000100 = 256
	        --reserved          ---------new branch (page# for root node)
		  --bad block


FlashSize 1G: bits 21
Data blocks: upto 2^21 0x4182..0xffeff first and last erase block reserved
Branch4: upto 2^14  0x182..0x4181
Branch3: upto 2^7   0x102..0x181
Branch2: upto 2^0   0x101
Root:    1          0x100

 */
