#define ASM
#include <vs1000.h>
//#include <vsNand.h>
#define NAND_OP_READ_SIGNATURE 0x90
#define NAND_OP_READ_STATUS 0x70
#define NAND_OP_READ_A 0x00
#define NAND_OP_READ_C 0x50
#define NAND_OP_COMMIT_DATA_ADDRESS 0x30
#define NAND_OP_PREPARE_TO_PROGRAM 0x80
#define NAND_OP_PERFORM_PROGRAM 0x10

// extern struct FsNandPhys fsNandPhys;
// s_int16 LargePageWrite(u_int32 page, u_int16 *data, u_int16 *meta) {

	.import _fsNandPhys
	.import _NandSetWaits,_NandPutCommand,_NandSwapBad,_NandPutOctets
	.import _NandGetStatus,_NandPutDataAddress

	.sect code,LargePageWrite	// 95 words -> 76 words
	.export _LargePageWrite
_LargePageWrite:	// PROLOGUE
	ldx (I6)+1,NULL	// Room for Sp and Fp
	stx MR0,(I6)+1 ; sty a1,(I6)
	stx LR0,(I6)+1 ; sty lc,(I6)	// return address
	stx I6,(I6) ; sty I4,(I6)
	ldx (I6)+1,I4	// FP' = SP, reserve space
	ldc 512,MR0
	stx I0,(I6)+1 ; sty I1,(I6)
	stx c0,(I6)+1 ; sty c1,(I6)
	stx I2,(I6)+1 ; sty I3,(I6)
	stx LE,(I6) ; sty LS,(I6)

//   PERIP(GPIO0_SET_MASK) = GPIO0_CS1;
//   NandSetWaits(fsNandPhys.waitns);

//   PERIP(GPIO0_CLEAR_MASK) = GPIO0_CS1;
//   NandPutCommand(NAND_OP_READ_A/*0x00*/);
//   NandPutCommand(NAND_OP_PREPARE_TO_PROGRAM/*0x80*/);
//   NandPutDataAddress(page);


	ldc GPIO0_SET_MASK,I0
	ldc GPIO0_CS1,A1
	stx A1,(I0)+(GPIO0_CLEAR_MASK-GPIO0_SET_MASK)/*V*/

	// field waitns, offset 12
	ldc _fsNandPhys+12,I1
	call _NandSetWaits	// Register parameter: A0, pass by value
	ldx (I1),A0	; ldy (I4)-4,NULL

	call _NandPutCommand	// Register parameter: A0, pass by value
	and NULL,NULL,A0	; stx A1,(I0)/*V*/

	call _NandPutCommand
	ldc NAND_OP_PREPARE_TO_PROGRAM,A0

	ldx (I4)+1,C0	// page
	call _NandPutDataAddress
	ldx (I4)-3,C1

//   {
//       register __c1 u_int16 i;
//       register __i3 u_int16 *m = meta;
//       register __i1 u_int16 *d = data;

	// 4 loops
	ldc 4-1,LS
	ldx (I4)+1,I3	// meta
	loop LS,LE7-1
	ldx (I4)-1,I1	// data

//       for (i=0;i<4;i++) {
// 	  PERIP(NFLSH_DSPIF) = NFLSH_DF_ECC_RESET;
// 	  NandPutOctets(512, d);
// 	  m[0] = PERIP(NFLSH_LPL);
// 	  m[1] = (PERIP(NFLSH_CP_LPH)<<8) | (m[1] & 0xff);
// 	  NandSwapBad(m);

	ldc NFLSH_DSPIF,I0
	sub NULL,ONES,A0	; mv I1,I2
	ldc 512,C0
	call _NandPutOctets	// Register parameter: I2, C0
	stx A0,(I0)+(NFLSH_LPL-NFLSH_DSPIF)/*V*/

	ldx (I0)+(NFLSH_CP_LPH-NFLSH_LPL),A0/*V*/
	ldx (I0),C0/*V*/
	stx A0,(I3)+1			//m[0]->m[1]
	ldc 8,A1
	ashl C0,A1,C0 ; ldx (I3)-1,A1	//m[1]->m[0]
	ldc 255,c1
	and A1,c1,A1	; mv I3,I0
	or C0,A1,C0	; ldx (i3)+1,null	//m[0]->m[1]

	call _NandSwapBad	// Register parameter: I0, pass by value
	stx C0,(I3)+7	//m[1] -> m[8]

// 	  d += 256;
// 	  m += 8;

	ldc 256,I0
	ldx (I1)*,NULL
LE7:
//       }
//   }
//   NandPutOctets(4*16,meta);
//   NandSwapBad(meta+0*8);
//   NandSwapBad(meta+1*8);
//   NandSwapBad(meta+2*8);
//   NandSwapBad(meta+3*8);

	ldc 4*16,C0
	call _NandPutOctets	// Register parameter: I2, C0
	ldx (I4),I2 	; ldy (I6),LS	// meta

	call _NandSwapBad
	ldx (I4),I0	// meta

	ldx (I4),I0	// meta
	ldc 1*8,I1
	call _NandSwapBad
	ldy (I0)*,NULL	; ldx (I6)-1,LE

	ldx (I4),I0	; ldy (I6),I3	// meta
	ldc 2*8,I1
	call _NandSwapBad
	ldy (I0)*,NULL	; ldx (I6)-1,I2

	ldx (I4)+6,I0	; ldy (i6),c1	// meta
	ldc 3*8,I1
	call _NandSwapBad
	ldy (I0)*,NULL	; ldx (I6)-1,c0

//   NandPutCommand(NAND_OP_PERFORM_PROGRAM/*0x10*/);

	call _NandPutCommand
	ldc NAND_OP_PERFORM_PROGRAM,A0

//   {
//       register u_int16 n = NandGetStatus();
//       PERIP(GPIO0_SET_MASK) = GPIO0_CS1;
//       return (n & 1) ? (s_int16)n : 0;

	call _NandGetStatus
	ldc GPIO0_SET_MASK,I0

	lsr A0,A1
	ldc GPIO0_CS1,A1
	jcs $17
	stx A1,(I0)/*V*/

	ldc 0,a0
$17:
	ldx (I6)-1,I0 ; ldy (I6),I1
	ldx (I4),I6 ; ldy (I4),I4	// Read Sp and Fp
	ldx (I6)-1,NULL
	ldx (I6)-1,LR0 ; ldy (I6),lc
	jr
	ldx (I6)-1,MR0 ; ldy (I6),a1

	.end
