#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vs1000.h>

#include <player.h>
#include <mappertiny.h>
#include <minifat.h>
#include <vsNand.h>

#include <dev1000.h>


/*
  NOTE: this version is for 8kB page size (MLC)!
 */

#define DEBUG_LEVEL 1

void fputhex6(u_int32 a, FILE *fp);
void puthex6(u_int32 a);
#include "mlc8k.h"
void NandPut8kDataAddress(register __c u_int32 addr);
u_int16 NandGetStatus(void);
extern struct FsNandPhys fsNandPhys;

s_int16 Large8kPageWrite(u_int32 page, u_int16 *data, u_int16 *meta) {
#if DEBUG_LEVEL > 1
    puthex6(page);
    puts("=LPW");
#endif
  PERIP(GPIO0_SET_MASK) = GPIO0_CS1; //NandDeselect(); /* For robustness */
  NandSetWaits(fsNandPhys.waitns);
  PERIP(GPIO0_CLEAR_MASK) = GPIO0_CS1;//  NandSelect();

  NandPutCommand(NAND_OP_READ_A);/*Sets read/write pointer*/
  NandPutCommand(NAND_OP_PREPARE_TO_PROGRAM);
  NandPut8kDataAddress(page & ~15L); /* not valid if low 4 bits set! */

#ifdef PERIP_IN_X
  #define GET_ECC (*(u_int32 *)NFLSH_LPL)
#else
  #define GET_ECC (*(__y u_int32 *)NFLSH_LPL)
#endif
  {
      register __c1 u_int16 i;
      register __i3 u_int16 *m = meta;
      register __i1 u_int16 *d = data;
      for (i=0;i<16;i++) {
	  PERIP(NFLSH_DSPIF) = NFLSH_DF_ECC_RESET;
#if 0 /*Generate ERRORS! */
	  /* calculate ECC from the original data */
	  m[0] = CalcECCBySoftware(d);
	  m[1] = ((CalcECCBySoftware(d) >> 16) << 8) | (m[1] & 0xff);
	  //puthex6(CalcECCBySoftware(d));
	  //putchar(' ');
	  if (page == 0) {
	      /* make errors */
	      puts("Gerating bit error");
	      if (i == 0) {
		  m[0] ^= 1;    /* error in ECC (don't care) */
	      } else {
		  d[i] ^= 1<<i; /* correctable error */
	      }
#if 0
	  } else if (page == 16) {
	      puts("Gerating bit error");
	      d[i] ^= 3;    /* uncorrectable error */
#endif
	  }
	  NandPutOctets(512, d);
#else
	  NandPutOctets(512, d);
	  m[0] = PERIP(NFLSH_LPL);
	  m[1] = (PERIP(NFLSH_CP_LPH)<<8) | (m[1] & 0xff);
#endif
#if DEBUG_LEVEL > 1
	  puthex6(GET_ECC);
	  puts("=ECC");
#endif
	  NandSwapBad(m);
	  d += 256;
	  m += 8;
      }
  }
  NandPutOctets(16*16,meta);
  /** Must restore the original order! */
  {
      register __c1 u_int16 i;
      register __i3 u_int16 *m = meta;
      for (i=0;i<16;i++) {
	  NandSwapBad(m);
	  m += 8;
      }
  }

  NandPutCommand(NAND_OP_PERFORM_PROGRAM); //Program the data and spare
  {
      register u_int16 n = NandGetStatus();
      PERIP(GPIO0_SET_MASK) = GPIO0_CS1;//      NandDeselect();

      /* Note: HY27UAG8T2BTR returns 0xe1 for the first status request,
	       0x70 to the next. */
#if DEBUG_LEVEL != 0
      //if (!IsValid(page)) {
      //puts("Fail!");
      //}
#if 0
      if (n & 1) {
	  //puthex(n);
	  //puts("=Wr");
      }
#endif
#endif
      return (n & 1); //(n & 1) ? (s_int16)n : 0; //Error code from flash      
  }
}




extern struct FsNandPhys fsNandPhys;
struct FmfMeta {
  u_int16 ecc01;
  u_int16 ecc2AndType;
  u_int16 reservedAndBadBlock;
  u_int16 unused;
  u_int32 logicalPageNo;	/* For root node, this is last used */
  s_int32 newBranch;		/* Page # for root node, non- -1 for others */
};
#define FS_MAP_NON_FULL 4

#define FMF_TYPE_INVALIDATED	  0
#define FMF_TYPE_ROOT		  1
#define FMF_TYPE_BRANCH2	  2
#define FMF_TYPE_BRANCH3	  3
#define FMF_TYPE_BRANCH4	  4
#define FMF_TYPE_DATA		  5
#define FMF_TYPE_UNUSED		255

#define FMF_BRANCH_LEVELS	4
#define FMF_EMPTY_BLOCKS	2


//s_int16 LargePageWrite(s_int32 page, u_int16 *data, u_int16 *meta);
s_int16 Large8kPageWrite(u_int32 page, u_int16 *data, u_int16 *meta);
s_int16 Large8kPageReadSingle(struct physical *ph, u_int32 page,
			      u_int16 sectors, u_int16 *data, u_int16 *meta);

extern struct FsPhysical *ph;
extern struct FsMapper *map;
extern struct Codec *cod;
//extern struct CodecServices cs;

__y const char hex[] = "0123456789abcdef";
void puthex(u_int16 a) {
  char tmp[8];
  tmp[0] = hex[(a>>12)&15];
  tmp[1] = hex[(a>>8)&15];
  tmp[2] = hex[(a>>4)&15];
  tmp[3] = hex[(a>>0)&15];
  tmp[4] = ' ';
  tmp[5] = '\0';
  fputs(tmp, stdout);
}
void fputhex6(u_int32 a, FILE *fp) {
  char tmp[8];
  tmp[0] = hex[(a>>20)&15];
  tmp[1] = hex[(a>>16)&15];
  tmp[2] = hex[(a>>12)&15];
  tmp[3] = hex[(a>>8)&15];
  tmp[4] = hex[(a>>4)&15];
  tmp[5] = hex[(a>>0)&15];
  tmp[6] = '\0';
  fputs(tmp, fp);
}
void puthex6(u_int32 a) {
    fputhex6(a, stdout);
}
#define NAN 0x80000000L
long GetParam(char *str) {
  static char in[200];
  char *tmp;
  register int i;
  long value;
  if (str) {
    fputs(str, stdout);
    fflush(stdout);
  }
  fgets(in, 200, stdin);
  i = strlen(in);
  while (i && (in[i-1] == '\n' || in[i-1] == '\r'))
    in[--i] = '\0';
  value = strtol(in, &tmp, 0);
  if (!in[0] || (tmp && *tmp && *tmp != '\n' && *tmp != '\r'))
    return NAN;
  return value;
}
void PrintSector(u_int16 *data, u_int16 *spare) {
#if 1
  register int i;
  if (data) {
    puts("d");
    for (i=0;i<256;i++) {
      puthex(data[i]);
      if ((i&7) == 7)
	putchar('\n');
    }
  }
  if (spare) {
    puts("s");
    for (i=0;i<8;i++)
      puthex(spare[i]);
    putchar('\n');
  }
#endif
}

#define NandSelect() USEX(GPIO0_ODATA) &= ~GPIO0_CS1
#define NandDeselect() USEX(GPIO0_ODATA) |= GPIO0_CS1
void NandPutCommand (register __a0 u_int16 command);
void NandPutBlockAddress(register __c u_int32 addr);
void NandPutDataAddress(register __c u_int32 addr);
void NandPutLargePageSpareAddress(register __c u_int32 addr);
u_int16 NandGetStatus(void);
void NandPutAddressOctet(register __a0 u_int16 address);
void NandGetOctets(register __c0 s_int16 length, register __i2 u_int16 *buf);

u_int16 NandGetIdent(void){
  u_int16 ident[4];
  NandDeselect();
  NandSelect();
  NandPutCommand(NAND_OP_READ_SIGNATURE);
  NandPutAddressOctet(0);
  NandGetOctets(8,ident);
  NandDeselect();
  fputs("Nand Signature: ",stdout);
  /*
    2cdc 9095 5400 MT29F4G08AAA
    ecd3 14a5 64ec K9G8G08U0A-PCB0   8Gb MLC  type=3 bl=9 sz=21
    ecd5 55a5 68ec K9LAG08U0A-PCB0  16Gb MLC  type=3 bl=9 sz=22 (2 dies)
    add3 14a5 34ad HY27UT088G2A-TPC8 8Gb MLC  type=3 bl=9 sz=21
    add3 14a5 64ad HY27UU08AG5M          MLC  type=3 bl=9 sz=22(21) (2 /CS, 2 R/B)
  */
  /*
    1st byte: maker code
    2nd byte: device code
    3rd & 4th byte: parameters
   */
#if 1
  {
    register int i;
    for (i=0; i<3; i++){
      puthex(ident[i]);
    }
  }
  fputs("\n",stdout);
#endif

#if 1
  puthex(1 << ((ident[1]>>8) & 3));
  puts("dies");
  puthex(((ident[1] >> 10) & 3) + 1);
  puts("bits/cell");
  puthex(1 << ((ident[1] >> 12) & 3));
  puts("sim.prog.pages");
  puts((ident[1] & 0x4000U) ? "Interleaved program" : "No interleaved program");
  puts((ident[1] & 0x8000U) ? "Cache program" : "No cache program");
  {
      static const char *pageSize[4] = {
	  "2kB page",
	  "4kB page",
	  "8kB page",
	  "reserved page size",
      };
      puts(pageSize[ident[1]&3]);
  }
  puthex(128 << ((ident[1] >> 4) & 3));
  puts("kB block");
  puthex(1<<((ident[2]>>10)&3));
  puts(" planes");
  if (0) {
      static const char *eccLevel[8] = {
	  "1bit/512B",
	  "2bit/512B",
	  "4bit/512B",
	  "8bit/512B",
	  "16bit/512B",
	  "24bit/1kB",
	  "reserved",
	  "reserved",
      };
      fputs("ECC Level: ", stdout);
      puts(eccLevel[((ident[2]>>12)&7)]);
  }
#endif
  return ident[0];
}
#include <audio.h>
#include <player.h>
#include <dev1000.h>
char in[200];
void main(void) {
    //ph = FsPhNandCreate(1);
    puts("starting");
#if 0
    clockX = 3;
    SetRate(1000);

    voltages[voltIoPlayer] = 30;
    PowerSetVoltages(&voltages[voltCorePlayer]);
#endif

#if 0
    /* In case we have parallel display, deassert CS */
    PERIP(GPIO0_DDR) |= 0x4000;
    PERIP(GPIO0_SET_MASK) = 0x4000; //CS2
#endif

#if 1
    ((struct FsNandPhys *)ph)->nandType = 3;
//    ((struct FsNandPhys *)ph)->waitns = 300;
#endif
    puthex(((struct FsNandPhys *)ph)->nandType);
    puts("=nT");
    puthex(((struct FsNandPhys *)ph)->waitns);
    puts("=ws");
    puthex6(ph->eraseBlockSize);
    puts("=eraseBlockSize");
    puthex6(ph->eraseBlocks);
    puts("=eraseBlocks");
    NandGetIdent();

#if 0 /* test spare read speed for updating eraseblock cache. */
    while (1)
    {
	register u_int16 eB, eraseBlockSize = ph->eraseBlockSize;
	s_int16 s, t = ReadTimeCount();

	s = PERIP(TIMER_T0CNTL);
	((struct FsNandPhys *)ph)->waitns = 25;
/*
  25ns, 2 spares from MLC
  256:  $1 2600  0.01s
  512:  $3 8800  0.03s
  1024: $6 a900  0.06s
  2048: $c ea00  0.12s
  4096: $19 8900 0.25s  one spare: 0.11s

 */
	for (eB = 0; eB < 4096/*ph->eraseBlocks*/; eB++) {
	    ph->Read(ph, (u_int32)eB * eraseBlockSize, 1,
		     NULL, (void *)tmpBuf);

	}
	s -= PERIP(TIMER_T0CNTL);
	t = ReadTimeCount() - t;
#if 0
	if (s < 0) {
	    s += 6000000/TIMER_TICKS;
	    t--;
	}
#endif
	puthex(t);
	puthex(s);
	puts("");
    }
#endif


//#define VERIFY_ONLY
    /* write image */
    {
	FILE *fp;
	int i;
	int errs;
    again:
	errs = 0;
	fp = fopen("boot.img", "rb");
	if (fp) {
	    u_int32 sector = 0;
#ifndef VERIFY_ONLY
	    ph->Erase(ph, 0);
#endif
	    puts("Writing");
	    PERIP(INT_ENABLEL) &= ~INTF_RX;
	    memset(mallocAreaX, -1, 8192/2);
#ifndef VERIFY_ONLY
	    while (fread(mallocAreaX, 1, 8192/2, fp)) {
		memset(minifatBuffer, -1, 16*16/2);
		if (Large8kPageWrite(sector, mallocAreaX, minifatBuffer)) {
		    puts("WrError");
		} else {
		    puts("Wr");
		}
		sector += 16;
		memset(mallocAreaX, -1, 8192/2);
	    }
	    //fclose(fp);
	    puthex(sector);
	    puts("=sectors written");
#endif
	    fseek(fp, 0, SEEK_SET);
	    sector = 0;

	    ph->Read = Large8kPageReadSingle;
	    puts("Verifying");
	    while (fread(mallocAreaX, 1, 512/2, fp)) {
		if (ph->Read(ph, sector, 1, mallocAreaX+256, minifatBuffer) != 1)
		    puts("read error");
		if (memcmp(mallocAreaX, mallocAreaX+256, 512/2)) {
		    puthex(sector);
		    puts("verify error");
		    for (i=0;i<256;i++) {
			if (mallocAreaX[i] != mallocAreaX[256+i]) {
			    errs++;
			}
#if 0 //ndef VERIFY_ONLY
			if (mallocAreaX[i] != mallocAreaX[256+i]) {
			    puthex(i);
			    puthex(mallocAreaX[i]);
			    puthex(mallocAreaX[256+i]);
			    puts("");
			}
#endif
		    }
		}
		sector += 1;
		memset(mallocAreaX, -1, 512/2);
	    }
	    fclose(fp);
	    PERIP(INT_ENABLEL) |= INTF_RX;
	}
	if (errs) {
	    puthex(errs);
	    puts("=errs, trying again");
	    ((struct FsNandPhys *)ph)->waitns++;
	    goto again;
	}
    }
    puts("Finished");
}
