#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vs1000.h>

#include <player.h>
#include <mappertiny.h>
#include <minifat.h>
#include <vsNand.h>

extern struct FsPhysical *ph;
extern struct FsMapper *map;

#define NandSelect() USEX(GPIO0_ODATA) &= ~GPIO0_CS1
#define NandDeselect() USEX(GPIO0_ODATA) |= GPIO0_CS1
void NandPutCommand (register __a0 u_int16 command);
void NandPutBlockAddress(register __c u_int32 addr);
void NandPutDataAddress(register __c u_int32 addr);
void NandPutLargePageSpareAddress(register __c u_int32 addr);
u_int16 NandGetStatus(void);
void NandPutAddressOctet(register __a0 u_int16 address);
void NandGetOctets(register __c0 s_int16 length, register __i2 u_int16 *buf);


void main(void) {
  PERIP(GPIO0_MODE) &= ~(GPIO0_CS1 | GPIO0_CLE | GPIO0_ALE);
  PERIP(GPIO0_DDR)  |= GPIO0_CS1;
  NandSelect(); //Pull down to prevent boot in FsPhNandCreate()
  ph = FsPhNandCreate(0);

  /* Send RESET command -- is mandatory with some flashes */
  NandDeselect();
  NandSelect();
  NandPutCommand(0xff /*NAND_OP_RESET*/);
  NandDeselect();

  PERIP(GPIO0_DDR) &= ~GPIO0_CS1;
  BusyWait10();
  /* Fall through to normal boot code -- NAND boot. */
}
